#   This program demonstrates using an open office spreadsheet as a
#   repository for FutoshikiFicki problems

#  Nigel_Galloway@operamail.com
#  July 29th., 2008.
#

require 'KuKu_vfs'

class FutoshikiFicki_vfs < KuKu_vfs
  def initialize(args)
    super(args);
    @rows = 5;
    @cols = 5;
    @Zymbolz=5;
  end

  def setFixed
    super
    addCells(1,1,1,1,5);
    addBlock(1,1,1);
    addCells(2,2,1,2,5);
    addBlock(2,2,2);
    addCells(3,3,1,3,5);
    addBlock(3,3,3);
    addCells(4,4,1,4,5);
    addBlock(4,4,4);
    addCells(5,5,1,5,5);
    addBlock(5,5,5);
    addCells(6,1,1,5,1);
    addBlock(6,6,6);
    addCells(7,1,2,5,2);
    addBlock(7,7,7);
    addCells(8,1,3,5,3);
    addBlock(8,8,8);
    addCells(9,1,4,5,4);
    addBlock(9,9,9);
    addCells(10,1,5,5,5);
    addBlock(10,10,10);
    addCells(11,1,1,5,5);
    addCblock(1,11,11);
    @sNo=12;
    @zNo=1;
    @eNo=1;
  end

  def handleCell(rN,cN,v)
    v=v[0];
    if v=='x' or rN>9 or cN>9 then return end
    r=(rN/2)+1;
    c=(cN/2)+1
    if (v=='1' or v=='2' or v=='3' or v=='4' or v=='5')
      addCells(@sNo,r,c,r,c);
      addZum(@zNo,@sNo,@sNo,v);
      @sNo+=1;
      @zNo+=1;
    end
		case v
		when 'A'
      addCells(@sNo,r-1,c,r-1,c);
      @sNo+=1;
      addCells(@sNo,r,c,r,c);
      addEqlz(@eNo,@sNo-1,@sNo-1,@sNo,@sNo);
      @sNo+=1;
      @eNo+=1;
		when 'V'
      addCells(@sNo,r,c,r,c);
      @sNo+=1;
      addCells(@sNo,r-1,c,r-1,c);
      addEqlz(@eNo,@sNo-1,@sNo-1,@sNo,@sNo);
      @sNo+=1;
      @eNo+=1;
		when '/'
      addCells(@sNo,r-1,c,r-1,c);
      @sNo+=1;
      addCells(@sNo,r,c-1,r,c-1);
      addEqlz(@eNo,@sNo-1,@sNo-1,@sNo,@sNo);
      @eNo+=1;
      addEqlz(@eNo,@sNo,@sNo,@sNo-1,@sNo-1);
      @sNo+=1;
      @eNo+=1;
		when '\\'
      addCells(@sNo,r-1,c-1,r-1,c-1);
      @sNo+=1;
      addCells(@sNo,r,c,r,c);
      addEqlz(@eNo,@sNo-1,@sNo-1,@sNo,@sNo);
      @eNo+=1;
      addEqlz(@eNo,@sNo,@sNo,@sNo-1,@sNo-1);
      @sNo+=1;
      @eNo+=1;
		when '&gt;'
      addCells(@sNo,r,c,r,c);
      @sNo+=1;
      addCells(@sNo,r,c-1,r,c-1);
      addEqlz(@eNo,@sNo-1,@sNo-1,@sNo,@sNo);
      @sNo+=1;
      @eNo+=1;
		when '&lt;'
      addCells(@sNo,r,c-1,r,c-1);
      @sNo+=1;
      addCells(@sNo,r,c,r,c);
      addEqlz(@eNo,@sNo-1,@sNo-1,@sNo,@sNo);
      @sNo+=1;
      @eNo+=1;
    else
		end
  end

end


FutoshikiFicki_vfs.new(ARGV).mount

